﻿//////////////////////////////////////////////
// LogManager.h
//
//////////////////////////////////////////////

/// Defines / Macros -------------------------

#pragma once

/// Forward decl -----------------------------

namespace nkLog
{
	class Logger ;
}

/// Includes ---------------------------------

// nkAstraeus
#include "../Dll/DllDefines.h"

// nkMemory
#include <NilkinsMemory/Containers/StringView.h>

// Common
#include <nilkinsCommon/Patterns/SingletonClass.h>

/// Class ------------------------------------
	
namespace nkAstraeus
{
	class DLL_ASTRAEUS_EXPORT LogManager : public nkCommon::SingletonClass<LogManager>
	{
		friend class nkCommon::SingletonClass<LogManager> ;

		private :

			// Constructeur, destructeur
			LogManager () ;
			~LogManager () ;

		private :

			// Le logger enregistré
			nkLog::Logger* _receiver ;

		public :

			// Getters
			nkLog::Logger* getReceiver () const ;

			// Setters
			void setReceiver (nkLog::Logger* receiver) ;

			// Log
			void log (const nkMemory::StringView& message, const nkMemory::StringView& className) ;
	} ;
}