﻿//////////////////////////////////////////////
// ScrollBar.h
//
//////////////////////////////////////////////

/// Defines / Macros -------------------------

#pragma once

/// Includes ---------------------------------

// nkWinUi
#include "Component.h"

#include "../Dll/DllDefines.h"

// Standards
#include <functional>

/// Class ------------------------------------

namespace nkWinUi
{
	class DLL_WINUI_EXPORT ScrollBar : public Component
	{
		protected :

			// Attributes
			// Callback when scrolling
			std::function<void(ScrollBar*)> _scrollCallback ;

			// Limits
			int _min ;
			int _max ;

			// Current state
			int _currentMin ;
			int _currentMax ;

		public :
	
			// Constructor, destructor
			ScrollBar () ;
			~ScrollBar () ;

			// Getters
			int getCurrentMin () const ;
			int getCurrentMax () const ;

			// Setters
			void setMin (int value) ;
			void setMax (int value) ;
			void setActiveRange (int value) ;
			void setScrollCallback (const std::function<void(ScrollBar*)>& callback) ;
			virtual void scrollToMin () ;
			virtual void scrollToMax () ;
			virtual void setScrollFactor (float value) = 0 ;
			virtual void moveCurrentMinTo (int value) ;
			virtual void moveCurrentMaxTo (int value) ;

			// Helpers
			virtual void scroll (float factor) = 0 ;
	} ;
}